<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Keepalived | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="Keepalived：最初给LVS负载均衡集群中的服务节点提供健康检查功能，后来因为集成了VRRP协议，可以实现解决服务节点的单点故障，提高服务的可靠性，支持高可用集群的部署 VRRP协议 VRRP（虚拟路由冗余协议）：由多台物理路由器组成一台高性能的虚拟路由器，多个物理路由器之间通过优先级举出主节点，其它节点为从节点，从节点不工作只接收主节点发来的VRRP通告，主节点管理虚拟IP并对外提供服务，">
<meta property="og:type" content="article">
<meta property="og:title" content="Keepalived">
<meta property="og:url" content="http://example.com/2021/01/21/Keepalived/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="Keepalived：最初给LVS负载均衡集群中的服务节点提供健康检查功能，后来因为集成了VRRP协议，可以实现解决服务节点的单点故障，提高服务的可靠性，支持高可用集群的部署 VRRP协议 VRRP（虚拟路由冗余协议）：由多台物理路由器组成一台高性能的虚拟路由器，多个物理路由器之间通过优先级举出主节点，其它节点为从节点，从节点不工作只接收主节点发来的VRRP通告，主节点管理虚拟IP并对外提供服务，">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-01-21T02:46:00.000Z">
<meta property="article:modified_time" content="2021-02-06T10:24:20.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/01/21/Keepalived/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2021-02-06 18:24:20'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Keepalived</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-01-21T02:46:00.000Z" title="发表于 2021-01-21 10:46:00">2021-01-21</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-02-06T10:24:20.000Z" title="更新于 2021-02-06 18:24:20">2021-02-06</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/KeepAlived/">KeepAlived</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><p>Keepalived：最初给LVS负载均衡集群中的服务节点提供健康检查功能，后来因为集成了VRRP协议，可以实现解决服务节点的单点故障，提高服务的可靠性，支持高可用集群的部署</p>
<p>VRRP协议</p>
<p>VRRP（虚拟路由冗余协议）：由多台物理路由器组成一台高性能的虚拟路由器，多个物理路由器之间通过优先级举出主节点，其它节点为从节点，从节点不工作只接收主节点发来的VRRP通告，主节点管理虚拟IP并对外提供服务，主节点定时给从节点发送VRRP通告，通告中包含着主节点的优先级，当从节点在计时器的时间到了之后接收不到主机点发送的VRRP通告时，就认为主节点不可用，此时，从节点就会根据优先级选举出新的主节点并接管虚拟IP对外提供服务，这个切换过程对于客户端来说是透明的，这样解决了单点故障，保证了服务的可用性</p>
<p>无故ARP（免费ARP）：特点是arp广播包中源IP目的IP源MAC目的MAC都是发送方的，也就是都是虚拟IP和虚拟MAC，</p>
<p>作用：</p>
<p>1.可以检测是否有地址冲突</p>
<p>2.可以更新终端设备的ARP缓存表</p>
<h3 id="实验环境："><a href="#实验环境：" class="headerlink" title="实验环境："></a>实验环境：</h3><table>
<thead>
<tr>
<th align="center">系统</th>
<th align="center">IP</th>
<th align="center">服务</th>
</tr>
</thead>
<tbody><tr>
<td align="center">Centos7.4</td>
<td align="center">1.1.1.1</td>
<td align="center">keepalived主</td>
</tr>
<tr>
<td align="center">Centos7.4</td>
<td align="center">1.1.1.2</td>
<td align="center">keepalived备</td>
</tr>
<tr>
<td align="center">Centos7.4</td>
<td align="center">1.1.1.3</td>
<td align="center">Nginx</td>
</tr>
<tr>
<td align="center">Centos7.4</td>
<td align="center">1.1.1.4</td>
<td align="center">Nginx</td>
</tr>
<tr>
<td align="center">*</td>
<td align="center">1.1.1.111</td>
<td align="center">VIP</td>
</tr>
<tr>
<td align="center">Centos7.4</td>
<td align="center">1.1.1.10</td>
<td align="center">Client</td>
</tr>
</tbody></table>
<h3 id="配置keepalived主"><a href="#配置keepalived主" class="headerlink" title="配置keepalived主"></a>配置keepalived主</h3><h4 id="使用yum安装keepalived服务"><a href="#使用yum安装keepalived服务" class="headerlink" title="使用yum安装keepalived服务"></a>使用yum安装keepalived服务</h4><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># yum -y install keepalived</span><br></pre></td></tr></table></figure>
<h4 id="修改配置文件"><a href="#修改配置文件" class="headerlink" title="修改配置文件"></a>修改配置文件</h4><figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br><span class="line">36</span><br><span class="line">37</span><br><span class="line">38</span><br><span class="line">39</span><br><span class="line">40</span><br><span class="line">41</span><br><span class="line">42</span><br><span class="line">43</span><br><span class="line">44</span><br><span class="line">45</span><br><span class="line">46</span><br><span class="line">47</span><br><span class="line">48</span><br><span class="line">49</span><br><span class="line">50</span><br><span class="line">51</span><br><span class="line">52</span><br><span class="line">53</span><br><span class="line">54</span><br><span class="line">55</span><br><span class="line">56</span><br></pre></td><td class="code"><pre><span class="line">vim /etc/keepalived/keepalived.conf</span><br><span class="line">global_defs &#123;			<span class="comment">//默认全局配置</span></span><br><span class="line">   notification_email &#123;		<span class="comment">//指定该keepalived节点故障时接收邮件的收信人</span></span><br><span class="line">     acassen<span class="meta">@firewall</span>.loc	</span><br><span class="line">     failover<span class="meta">@firewall</span>.loc	</span><br><span class="line">     sysadmin<span class="meta">@firewall</span>.loc	</span><br><span class="line">   &#125;</span><br><span class="line">   notification_email_from Alexandre.Cassen<span class="meta">@firewall</span>.loc		<span class="comment">//keepalived故障时发送邮件的发信人</span></span><br><span class="line">   smtp_server <span class="number">192.168</span><span class="number">.200</span><span class="number">.1</span>		<span class="comment">//指定邮件服务器的IP，stmp简单邮件传输协议，使用端口25</span></span><br><span class="line">   smtp_connect_timeout <span class="number">30</span>		<span class="comment">//与邮件服务器的连接超时时间，单位s，可以自定义</span></span><br><span class="line">   router_id master		<span class="comment">//该节点的唯一表示，用于发邮件时表示该节点，可以是主机名，也可以是自己指定的名字</span></span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">vrrp_instance VI_1 &#123;		<span class="comment">//定义一个VRRP实例，处于同一个组中的节点使用的实例名字应该一致，默认使用名字VI_1</span></span><br><span class="line">    state MASTER		<span class="comment">//该节点的状态，MASTER为主，BACKUP为备，必须大写，但是只是用来标识节点状态，节点主备是由优先级决定的</span></span><br><span class="line">    <span class="class"><span class="keyword">interface</span> <span class="title">ens33</span>		//指定主节点从那块网卡发送<span class="title">VRRP</span>通告</span></span><br><span class="line"><span class="class">    <span class="title">virtual_router_id</span> 51		//指定该实例所属的虚拟路由组的<span class="title">id</span>，属于同一个组的节点使用的<span class="title">id</span>应该相同，<span class="title">id</span>取值范围为0-255</span></span><br><span class="line"><span class="class">    <span class="title">priority</span> 100		//指定该节点的优先级，属于同一个组的节点优先级最高为主节点，取值范围为1-255，配置超过取值范围的值都默认视为100</span></span><br><span class="line"><span class="class">添加：<span class="title">nopreempt</span>		//将该节点设置为非抢占模式</span></span><br><span class="line"><span class="class">    <span class="title">advert_int</span> 1		//主节点每隔1<span class="title">s</span>发送一次<span class="title">VRRP</span>通告，时间可以自定义</span></span><br><span class="line"><span class="class">    <span class="title">authentication</span> </span>&#123;		<span class="comment">//配置主备节点之间的认证方式以及密码</span></span><br><span class="line">        auth_type PASS		<span class="comment">//认证类型，主备必须一致，有PASS和HA两种，PASS密码是明文的，HA是密文的</span></span><br><span class="line">        auth_pass <span class="number">1111</span>		<span class="comment">//认证密钥，主备必须一致，只识别前八位</span></span><br><span class="line">    &#125;</span><br><span class="line">    virtual_ipaddress &#123;		<span class="comment">//配置虚拟IP，只有主节点才会拥有该地址，只能通过ip add查看，ifconfig是查看不到的</span></span><br><span class="line">        <span class="number">1.1</span><span class="number">.1</span><span class="number">.111</span>/<span class="number">8</span>		<span class="comment">//与物理机IP同网段</span></span><br><span class="line">    &#125;</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">virtual_server <span class="number">1.1</span><span class="number">.1</span><span class="number">.111</span> <span class="number">80</span> &#123;		<span class="comment">//指定LVS集群使用的虚拟IP以及端口</span></span><br><span class="line">    delay_loop <span class="number">6</span>		<span class="comment">//指定对服务节点进行健康检查的间隔时间</span></span><br><span class="line">    lb_algo rr 		<span class="comment">//该集群的使用的调度算法</span></span><br><span class="line">    lb_kind DR		<span class="comment">//该集群的调度模式</span></span><br><span class="line">    persistence_timeout <span class="number">0</span>		<span class="comment">//服务节点的连接时间，0表示为短链接</span></span><br><span class="line">    protocol TCP		<span class="comment">//集群中节点之间通过TCP协议通信</span></span><br><span class="line">    netmask <span class="number">255.0</span><span class="number">.0</span><span class="number">.0</span>	<span class="comment">//VIP掩码</span></span><br><span class="line"></span><br><span class="line">	real_server <span class="number">1.1</span><span class="number">.1</span><span class="number">.3</span> <span class="number">80</span> &#123;		<span class="comment">//向集群中添加服务节点</span></span><br><span class="line">   	weight <span class="number">1</span>		<span class="comment">//设置节点的权重，默认为1，如果权重为0则表示该节点不可用</span></span><br><span class="line">	   TCP_CHECK &#123;	<span class="comment">//启用TCP健康检查</span></span><br><span class="line">            connect_timeout <span class="number">1</span>		<span class="comment">//对服务节点做健康检查的连接超时时间，1s可以自定义</span></span><br><span class="line">            nb_get_retry <span class="number">3</span>		<span class="comment">//所健康检查的重试次数，可自定义</span></span><br><span class="line">            delay_before_retry <span class="number">1</span>		<span class="comment">//每次健康检查之间间隔时间，可自定义</span></span><br><span class="line">            connect_port <span class="number">80</span>		<span class="comment">//针对哪个端口进行TCP检查</span></span><br><span class="line">            &#125;</span><br><span class="line">	 &#125;</span><br><span class="line">	real_server <span class="number">1.1</span><span class="number">.1</span><span class="number">.4</span> <span class="number">80</span> &#123;		</span><br><span class="line">   	weight <span class="number">1</span></span><br><span class="line">	   TCP_CHECK &#123;</span><br><span class="line">            connect_timeout <span class="number">3</span>	</span><br><span class="line">            nb_get_retry <span class="number">3</span>	</span><br><span class="line">            delay_before_retry <span class="number">3</span></span><br><span class="line">            connect_port <span class="number">80</span></span><br><span class="line">            &#125;</span><br><span class="line">     &#125;</span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>
<h4 id="将配置文件拷贝给keepalived备"><a href="#将配置文件拷贝给keepalived备" class="headerlink" title="将配置文件拷贝给keepalived备"></a>将配置文件拷贝给keepalived备</h4><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># scp /etc/keepalived/keepalived.conf root@1.1.1.2:/etc/keepalived/keepalived.conf</span><br></pre></td></tr></table></figure>
<h4 id="修改备的配置文件"><a href="#修改备的配置文件" class="headerlink" title="修改备的配置文件"></a>修改备的配置文件</h4><figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># vi /etc/keepalived/keepalived.conf</span><br><span class="line">router_id backup</span><br><span class="line">state BACKUP</span><br><span class="line">priority <span class="number">90</span></span><br></pre></td></tr></table></figure>
<h4 id="启动主从的keepalived服务"><a href="#启动主从的keepalived服务" class="headerlink" title="启动主从的keepalived服务"></a>启动主从的keepalived服务</h4><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># systemctl restart keepalived</span><br></pre></td></tr></table></figure>
<h4 id="配置Nginx（两台同样步骤）"><a href="#配置Nginx（两台同样步骤）" class="headerlink" title="配置Nginx（两台同样步骤）"></a>配置Nginx（两台同样步骤）</h4><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br></pre></td><td class="code"><pre><span class="line"># 配置虚拟IP</span><br><span class="line"># cd /etc/sysconfig/network-scripts/</span><br><span class="line"># cp ifcfg-lo ifcfg-lo:1</span><br><span class="line"># vi ifcfg-lo:1</span><br><span class="line">DEVICE=lo:<span class="number">1</span></span><br><span class="line">IPADDR=<span class="number">1.1</span><span class="number">.1</span><span class="number">.111</span>	<span class="comment">//虚拟IP</span></span><br><span class="line">NETMASK=<span class="number">255.255</span><span class="number">.255</span><span class="number">.255</span></span><br><span class="line">NAME=lo:<span class="number">1</span></span><br><span class="line"># 多余的删除</span><br></pre></td></tr></table></figure>
<blockquote>
<p>可以通过ifconfig命令来配置不过是临时IP重启失效</p>
</blockquote>
<blockquote>
<p>ifconfig lo:1 1.1.1.111 netmask 255.255.255.255</p>
</blockquote>
<h4 id="重启网卡"><a href="#重启网卡" class="headerlink" title="重启网卡"></a>重启网卡</h4><figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">systemctl restart network</span><br></pre></td></tr></table></figure>
<h4 id="修改系统内核文件"><a href="#修改系统内核文件" class="headerlink" title="修改系统内核文件"></a>修改系统内核文件</h4><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line"># vim /etc/sysctl.conf</span><br><span class="line">net.ipv4.conf.lo.arp_ignore=<span class="number">1</span></span><br><span class="line">net.ipv4.conf.<span class="keyword">default</span>.arp_ignore=<span class="number">1</span>	</span><br><span class="line">net.ipv4.conf.all.arp_ignore=<span class="number">1</span></span><br><span class="line">net.ipv4.conf.lo.arp_announce=<span class="number">2</span></span><br><span class="line">net.ipv4.conf.<span class="keyword">default</span>.arp_announce=<span class="number">2</span></span><br><span class="line">net.ipv4.conf.all.arp_announce=<span class="number">2</span></span><br><span class="line"># sysctl -p</span><br></pre></td></tr></table></figure>
<h4 id="修改web首页文件（第二台web改成NO-2）"><a href="#修改web首页文件（第二台web改成NO-2）" class="headerlink" title="修改web首页文件（第二台web改成NO.2）"></a>修改web首页文件（第二台web改成NO.2）</h4><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># echo &quot;Wecom to nginx NO.1&quot; &gt; /usr/local/nginx/html/index.html</span><br></pre></td></tr></table></figure>
<h4 id="放行防护墙"><a href="#放行防护墙" class="headerlink" title="放行防护墙"></a>放行防护墙</h4><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># firewall-cmd --add-port=80/tcp --permanent</span><br><span class="line"># firewall-cmd --add-service=nginx --permanent</span><br><span class="line"># firewall-cmd --reload</span><br><span class="line"># setenforce 0</span><br></pre></td></tr></table></figure>
<h4 id="客户端验证"><a href="#客户端验证" class="headerlink" title="客户端验证"></a>客户端验证</h4><figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># curl 1.1.1.111</span><br><span class="line">wecom to nginx NO<span class="number">.1</span></span><br></pre></td></tr></table></figure></article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/01/21/Keepalived/">http://example.com/2021/01/21/Keepalived/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/01/21/kubeadm%E9%83%A8%E7%BD%B2%E5%8D%95Master-K8S%E9%9B%86%E7%BE%A4/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Kubeadm部署单Master-K8S集群</div></div></a></div><div class="next-post pull-right"><a href="/2021/01/21/Linux%E7%8E%AF%E5%A2%83%E6%9B%B4%E6%96%B0Python3-8/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Linux环境更新Python3.8</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%AE%9E%E9%AA%8C%E7%8E%AF%E5%A2%83%EF%BC%9A"><span class="toc-number">1.</span> <span class="toc-text">实验环境：</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%85%8D%E7%BD%AEkeepalived%E4%B8%BB"><span class="toc-number">2.</span> <span class="toc-text">配置keepalived主</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E4%BD%BF%E7%94%A8yum%E5%AE%89%E8%A3%85keepalived%E6%9C%8D%E5%8A%A1"><span class="toc-number">2.1.</span> <span class="toc-text">使用yum安装keepalived服务</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6"><span class="toc-number">2.2.</span> <span class="toc-text">修改配置文件</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%B0%86%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6%E6%8B%B7%E8%B4%9D%E7%BB%99keepalived%E5%A4%87"><span class="toc-number">2.3.</span> <span class="toc-text">将配置文件拷贝给keepalived备</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9%E5%A4%87%E7%9A%84%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6"><span class="toc-number">2.4.</span> <span class="toc-text">修改备的配置文件</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%90%AF%E5%8A%A8%E4%B8%BB%E4%BB%8E%E7%9A%84keepalived%E6%9C%8D%E5%8A%A1"><span class="toc-number">2.5.</span> <span class="toc-text">启动主从的keepalived服务</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%85%8D%E7%BD%AENginx%EF%BC%88%E4%B8%A4%E5%8F%B0%E5%90%8C%E6%A0%B7%E6%AD%A5%E9%AA%A4%EF%BC%89"><span class="toc-number">2.6.</span> <span class="toc-text">配置Nginx（两台同样步骤）</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%87%8D%E5%90%AF%E7%BD%91%E5%8D%A1"><span class="toc-number">2.7.</span> <span class="toc-text">重启网卡</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9%E7%B3%BB%E7%BB%9F%E5%86%85%E6%A0%B8%E6%96%87%E4%BB%B6"><span class="toc-number">2.8.</span> <span class="toc-text">修改系统内核文件</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E4%BF%AE%E6%94%B9web%E9%A6%96%E9%A1%B5%E6%96%87%E4%BB%B6%EF%BC%88%E7%AC%AC%E4%BA%8C%E5%8F%B0web%E6%94%B9%E6%88%90NO-2%EF%BC%89"><span class="toc-number">2.9.</span> <span class="toc-text">修改web首页文件（第二台web改成NO.2）</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E6%94%BE%E8%A1%8C%E9%98%B2%E6%8A%A4%E5%A2%99"><span class="toc-number">2.10.</span> <span class="toc-text">放行防护墙</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%AE%A2%E6%88%B7%E7%AB%AF%E9%AA%8C%E8%AF%81"><span class="toc-number">2.11.</span> <span class="toc-text">客户端验证</span></a></li></ol></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>